#!/usr/bin/env python
# -*- coding: UTF-8 -*-

import urllib, urllib2, re, sys, xml.dom.minidom, optparse


class Post:
	"""Class wich represents a post. It has a title, link and number of users"""
	pass


def get_posts(feed):
	"""Read the xml passed as parameter and returns a list of post objects with
	the title and link of each post defined in the file"""
	posts = []
	urllib.urlcleanup() # clear the cache
	print "Downloading and parsing xml"
	try:
		document = xml.dom.minidom.parse(urllib.urlopen(feed))
	except xml.parsers.expat.ExpatError, e:
		print "The document is not a wellformed XML file."
		exit(-1)
	lista = document.getElementsByTagName("item")
	if lista:
		print "It seems to be a RSS feed"
		for item in lista:
			post = Post()
			post.title = item.getElementsByTagName("title")[0].firstChild.data
			post.link = item.getElementsByTagName("link")[0].firstChild.data
			posts.append(post)
		return posts

	lista = document.getElementsByTagName("url")
	if lista:
		print "It seems to be a sitemap"
		for item in lista:
			post = Post()
			post.title = item.getElementsByTagName("loc")[0].firstChild.data
			post.link = item.getElementsByTagName("loc")[0].firstChild.data
			posts.append(post)
		return posts

	print "Error. This application only accepts RSS feeds and sitemaps"
	exit(-1)


def get_count(posts):
	"""Retrive from del.icio.us the number of persons who bookmarked each post
	in the list"""
	new_posts = []
	print("Searching for posts on del.icio.us")
	i = 0
	for post in posts:
		i = i + 1
		values = {'url':post.link, 'submit':"check url"}
		data = urllib.urlencode(values)
		request = urllib2.Request("http://del.icio.us/url/check", data)
		try:
			response = urllib2.urlopen(request)
		except urllib2.URLError, e:
			print "Delicious sent an error code. Enough for now."
			print e
			return new_posts
		page = response.read()
		
		found = re.search("this url has been saved by (\S+) people.", page)
		
		if found:
			post.count = int(found.group(1))
			print i, post.title + ": " + str(post.count)
			new_posts.append(post)
		else:
			post.count = 0
			print i, post.title + ": " + str(post.count)
			new_posts.append(post)
	print "\n"
	return new_posts

def main():
	parser = optparse.OptionParser()
	parser.add_option("-u", "--url", dest="url", help="Url of the RSS or sitemap")
	(options, args) = parser.parse_args()
		
	feed = options.url
	
	if not feed:
		print "You must specify the URL to process. Use -h for help."
		exit(-1)
	
	posts = get_posts(feed)
	posts = get_count(posts)
	if posts: posts.sort(lambda p1, p2: p2.count - p1.count)

	for post in posts:
		print post.title + ": " + str(post.count)


if __name__ == "__main__":
	main()
